<?php

namespace FM\Factory;

use Doctrine\ORM\EntityManager;
use Teknisa\Model\Traits\TQuery;

class FmtOrdemServFactory
{
    use TQuery;
    protected $connection;
    protected $entityManager;

    public function __construct(EntityManager $entityManager)
    {
        $this->connection = $entityManager->getConnection();
        $this->entityManager = $entityManager;
    }

    public function getOrdensServico()
    {
        $sql = "SELECT OSE.NMORDEMOSERV, OSE.NRORDEMSERV, TO_CHAR(OSE.DTORDEMSERV, 'DD/MM/YY') DTORDEMSERV, OSE.IDSITUACAO, EP.NMEQUIPAMENTO,
                CAT.NMCATEGORIAMANUT, TM.NMTIPOMANUTENCAO, P.NMPRIORIDADEMANUT, P.DSCORPRIORIDADE, OSE.NREQUIPAMENTO,
                OSE.NRCATEGORIAMANUT, OSE.NRTIPOMANUTENCAO, OSE.NRPRIORIDADEMANUT, OSE.DSORDEMSERV, FCM_LOCALCLI.NMLOCALCLIENTE,
                        FCM_LOCALCLI.CDCLIENTE,
                        CLIENTE.NMFANTCLIE,
                        OSE.NRLOCALCLIENTE,
                        OSE.NREQUIPE,
                (SELECT RTRIM(XMLAGG(XMLELEMENT(E, FCM_RESPONSAVELORDEMS.CDOPERADOR || ',').EXTRACT('//text()')).GETCLOBVAL(), ',')
                            FROM  FCM_RESPONSAVELORDEMS
                            WHERE  FCM_RESPONSAVELORDEMS.NRORDEMSERV = OSE.NRORDEMSERV ) AS CDOPERADOR,
                 (SELECT RTRIM(XMLAGG(XMLELEMENT(E, FCM_RESPONSAVELORDEMS.NRPROFISSIONALEXTERNO || ',').EXTRACT('//text()')).GETCLOBVAL(), ',')
                            FROM  FCM_RESPONSAVELORDEMS
                            WHERE  FCM_RESPONSAVELORDEMS.NRORDEMSERV = OSE.NRORDEMSERV ) AS NRPROFISSIONALEXTERNO,
                NVL((SELECT LISTAGG(FCM_ESCOPOMANUT.NMESCOPOMANUT, ',')
                    WITHIN GROUP (ORDER BY FCM_ESCOPOMANUT.NRESCOPOMANUT)
                    FROM FCM_RELESCORDEMSERV
                    JOIN FCM_ESCOPOMANUT
                    ON FCM_RELESCORDEMSERV.NRESCOPOMANUT = FCM_ESCOPOMANUT.NRESCOPOMANUT
                    WHERE OSE.NRORDEMSERV = FCM_RELESCORDEMSERV.NRORDEMSERV), ' ') NMESCOPOMANUT,
                 CASE OSE.IDSITUACAO WHEN '1' THEN 'Pendente'
                    WHEN '2' THEN 'Em Andamento'
                    WHEN '3' THEN 'Concluído'
                    WHEN '4' THEN 'Recusada'
                    WHEN '3' THEN 'Pausada'
                    ELSE NULL END AS NMIDSITUACAO
                 FROM FCM_ORDEMSERV OSE
                 JOIN FCM_PRIORIDADEMANUT P
                   ON P.NRPRIORIDADEMANUT = OSE.NRPRIORIDADEMANUT
                 JOIN FCM_EQUIPAMENTO EP
                   ON EP.NREQUIPAMENTO = OSE.NREQUIPAMENTO
                 JOIN FCM_CATEGORIAMANUT CAT
                   ON CAT.NRCATEGORIAMANUT = OSE.NRCATEGORIAMANUT
                 JOIN FCM_TIPOMANUTENCAO TM
                   ON TM.NRTIPOMANUTENCAO = OSE.NRTIPOMANUTENCAO
         LEFT JOIN FCM_LOCALCLI
                    ON FCM_LOCALCLI.NRLOCALCLIENTE = OSE.NRLOCALCLIENTE
         LEFT JOIN CLIENTE
                   ON FCM_LOCALCLI.CDCLIENTE = CLIENTE.CDCLIENTE
        ORDER BY DTORDEMSERV DESC";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, [],[], null, null, null, array('NRPROFISSIONALEXTERNO', 'CDOPERADOR'));
    }

    // public function getComentariosSolicitacao($parametros)
    // {
    //     $sql = "SELECT COMENT.NRCOMENTSOLICITSERV, NVL(OPER.NMOPERADOR, 'Anônimo') AS NMOPERADOR, TO_CHAR(COMENT.DTINCLUSAO, 'DD/MM/YYYY') AS DTINCLUSAO, COMENT.DSCOMENTARIO
    //             FROM FCM_COMENTSOLICITSERV COMENT
    //             LEFT JOIN OPERADOR OPER
    //             ON COMENT.CDOPERCOMENTARIO = OPER.CDOPERADOR
    //             WHERE COMENT.NRSOLICITACAOSERV = :NRSOLICITACAOSERV
    //             ORDER BY DTINCLUSAO, NRCOMENTSOLICITSERV DESC";

    //     return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $parametros);
    // }

 
    public function getComentariosOrdem($parametros)
    {
        $sql = "SELECT COMENT.NRCOMENTORDEMSERV, NVL(FUNC.NMFUNCIONARIO,'Sem nome') NMFUNCIONARIO, TO_CHAR(COMENT.DTCOMENTARIO, 'DD/MM/YYYY') AS DTCOMENTARIO, COMENT.DSCOMENTARIO
                FROM FCM_COMENTORDEMSERV COMENT
                LEFT JOIN FCM_FUNCIONARIO FUNC
                ON COMENT.NRFUNCCOMENTARIO = FUNC.NRFUNCIONARIO
                WHERE COMENT.NRORDEMSERV = :NRORDEMSERV
                ORDER BY DTCOMENTARIO, NRCOMENTORDEMSERV DESC";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $parametros);
    }
//     public function getComentariosOrdem($parametros)
//     {
//         $sql = "SELECT COMENT.NRFUNCCOMENTARIO, FUNC.CDOPERADOR, 
//        COMENT.NRCOMMENTORDEMSERV, NVL(FUNC.NMOPERADOR,'Sem nome') AS NMOPERADOR,  
//        TO_CHAR(COMENT.DTCOMENTARIO, 'DD/MM/YYYY') AS DTCOMENTARIO, COMENT.DSCOMENTARIO
// FROM FCM_COMENTORDEMSERV COMENT
// LEFT JOIN OPERADOR FUNC
// ON COMENT.NRFUNCCOMENTARIO = FUNC.CDOPERADOR
// WHERE COMENT.NRORDEMSERV = :NRORDEMSERV
// ORDER BY DTCOMENTARIO, NRCOMMENTORDEMSERV DESC;
// ";

//         return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $parametros);
//     }


    public function insertOrdemServico($parametros)
    {
        $sql = "INSERT INTO FCM_ORDEMSERV(
                    NRORDEMSERV,        NMORDEMOSERV,       IDSITUACAO,     NREQUIPAMENTO,  NRCATEGORIAMANUT,
                    NRTIPOMANUTENCAO,   NRPRIORIDADEMANUT,  DSORDEMSERV,    DTINCLUSAO,    
                    NRORG,              DTORDEMSERV,        NRSOLICITACAOSERV, NRLOCALCLIENTE, NRMODELOPOP, NREQUIPE, IDTAREFARESPONSAVEL
                )
                VALUES(
                    :NRORDEMSERV,       :NMORDEMOSERV,       :IDSITUACAO,    :NREQUIPAMENTO, :NRCATEGORIAMANUT,
                    :NRTIPOMANUTENCAO,  :NRPRIORIDADEMANUT, :DSORDEMSERV,   SYSDATE,        
                    :NRORG,             TO_DATE(:DTORDEMSERV, 'DD/MM/YYYY'), :NRSOLICITACAOSERV, :NRLOCALCLIENTE, :NRMODELOPOP, :NREQUIPE, :IDTAREFARESPONSAVEL
                )";

        $this->connection->executeStatement($sql, $parametros);
    }

    public function insertFotoOrdem($parametros)
    {
        $sql = "INSERT INTO FCM_IMGORDEMSERV (
                    NRIMGORDEMSERV,     NRORDEMSERV,    DSCAMINHO,  NRORG,
                    DTINCLUSAO,         DSTYPE,         NRSIZE
                )
                VALUES (
                    :NRIMGORDEMSERV,    :NRORDEMSERV,   :DSCAMINHO, :NRORG,
                    SYSDATE,            :DSTYPE,        :NRSIZE
                )";

        $this->connection->executeStatement($sql, $parametros);
    }

    public function saveComentarioOrdem($parametros)
    {
        $sql = "INSERT INTO FCM_COMENTORDEMSERV (
                    NRCOMENTORDEMSERV,  NRORDEMSERV,    DTCOMENTARIO,   DSCOMENTARIO
                )
                VALUES (
                    :NRCOMENTORDEMSERV, :NRORDEMSERV,   SYSDATE,        :DSCOMENTARIO
                )";

        $this->connection->executeStatement($sql, $parametros);
    }

    public function inserirEscopoRelacionado($parametros)
    {

        $sql = "INSERT INTO FCM_RELESCORDEMSERV (NRRELESCORDEMSERV, NRORDEMSERV, NRESCOPOMANUT, DTINCLUSAO)
              VALUES  (:NRRELESCORDEMSERV, :NRORDEMSERV, :NRESCOPOMANUT, SYSDATE)";

        $this->connection->executeStatement($sql, $parametros);
    }

    public function insertRelEscopoOrdem($parametros)
    {
        $sql = "INSERT INTO FCM_RELESCORDEMSERV(
                    NRRELESCORDEMSERV,  NRORDEMSERV,    NRESCOPOMANUT,  DTINCLUSAO
                )
                VALUES(
                    :NRRELESCORDEMSERV, :NRORDEMSERV,   :NRESCOPOMANUT, SYSDATE
                )";

        $this->connection->executeStatement($sql, $parametros);
    }

    public function insertRelSolicitacaoOrdem($parametros)
    {
        $sql = "INSERT INTO FCM_RELSOLICITAORDEMSERV(
                    NRRELSOLICITAORDEMSERV,     NRSOLICITACAOSERV,  NRORDEMSERV,
                    IDATIVO,                    DTINCLUSAO
                )
                VALUES(
                    :NRRELSOLICITAORDEMSERV,    :NRSOLICITACAOSERV, :NRORDEMSERV,
                    'S',                        SYSDATE
                )";

        $this->connection->executeStatement($sql, $parametros);
    }

    public function insertHistorico($parametros)
    {
        $sql = "INSERT INTO FCM_ORDEMSERVHISTORICO(
                    NRORDEMSERVHISTORICO,   NRSOLICITACAOSERV,  NRORDEMSERV, 
                    DTHISTORDEMSERV,        IDATIVO,            DSORDEMSERVHISTORICO, 
                    NRORG,                  DTINCLUSAO,         CDOPERINCLUSAO, 
                    NRORGINCLUSAO
                )
                VALUES(
                    :NRORDEMSERVHISTORICO,   :NRSOLICITACAOSERV, :NRORDEMSERV, 
                    SYSDATE,                 'S',                :DSORDEMSERVHISTORICO, 
                    :NRORG,                   SYSDATE,           :CDOPERINCLUSAO, 
                    :NRORG
                )";

        $this->connection->executeStatement($sql, $parametros);
    }

    public function getHistoricoOrdemServ($parametros) 
    {
        $sql = "SELECT FCM_ORDEMSERVHISTORICO.NRORDEMSERVHISTORICO, FCM_ORDEMSERVHISTORICO.NRSOLICITACAOSERV, FCM_ORDEMSERVHISTORICO.NRORDEMSERV, 
                FCM_ORDEMSERVHISTORICO.DSORDEMSERVHISTORICO, FCM_ORDEMSERVHISTORICO.DTHISTORDEMSERV, OPERADOR.CDOPERADOR, OPERADOR.NMOPERADOR
                FROM FCM_ORDEMSERVHISTORICO
                JOIN OPERADOR ON OPERADOR.CDOPERADOR = FCM_ORDEMSERVHISTORICO.CDOPERINCLUSAO
                WHERE NRORDEMSERV = :NRORDEMSERV";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $parametros);
    }

    public function getFotoOrdem($parametros)
    {
        $sql = "SELECT 
        NRIMGORDEMSERV,
        NRORDEMSERV,
        DSCAMINHO,
        NRORG,
        DTINCLUSAO,
        DSTYPE,
        NRSIZE
    FROM 
        FCM_IMGORDEMSERV";

        $this->connection->executeStatement($sql, $parametros);
    }


    /* Rotina do Kanban */

    public function getDadosKanban($parametros)
    {
        $sql = "SELECT 
                        'Ordem' AS TIPO,
                        OSE.NMORDEMOSERV AS NOME, 
                        OSE.NRORDEMSERV AS CODIGO, 
                        TO_CHAR(OSE.DTORDEMSERV, 'DD/MM/YY') AS DATA, 
                        OSE.IDSITUACAO AS SITUACAO,
                        OSE.NRPRIORIDADEMANUT AS PRIORIDADE, 
                        OSE.DSORDEMSERV AS DESCRICAO,
                        FCM_LOCALCLI.CDCLIENTE,
                        FCM_LOCALCLI.NMLOCALCLIENTE,
                        CLIENTE.NMFANTCLIE,
                        OSE.NRLOCALCLIENTE
                FROM FCM_ORDEMSERV OSE
                    JOIN FCM_PRIORIDADEMANUT P
                    ON P.NRPRIORIDADEMANUT = OSE.NRPRIORIDADEMANUT
                LEFT JOIN FCM_LOCALCLI
                    ON FCM_LOCALCLI.NRLOCALCLIENTE = OSE.NRLOCALCLIENTE
                LEFT JOIN CLIENTE
                   ON FCM_LOCALCLI.CDCLIENTE = CLIENTE.CDCLIENTE
                    WHERE OSE.IDSITUACAO = :IDSITUACAO
                                
                UNION ALL 
                                
                SELECT 
                        'Solicitação' AS TIPO,
                        SOLSERV.NMSOLICITACAOSERV AS NOME, 
                        SOLSERV.NRSOLICITACAOSERV AS CODIGO, 
                        TO_CHAR(SOLSERV.DTSOLICITACAOSERV, 'DD/MM/YY') AS DATA, 
                        SOLSERV.IDSITUACAO AS SITUACAO,
                        SOLSERV.NRPRIORIDADEMANUT AS PRIORIDADE,
                        SOLSERV.DSSOLICITACAOSERV AS DESCRICAO,
                        FCM_LOCALCLI.CDCLIENTE,
                        CLIENTE.NMFANTCLIE,
                        FCM_LOCALCLI.NMLOCALCLIENTE,
                        SOLSERV.NRLOCALCLIENTE
                    FROM 
                        FCM_SOLICITACAOSERV SOLSERV
                        JOIN FCM_PRIORIDADEMANUT P
                        ON P.NRPRIORIDADEMANUT = SOLSERV.NRPRIORIDADEMANUT
                    LEFT JOIN FCM_LOCALCLI
                        ON FCM_LOCALCLI.NRLOCALCLIENTE = SOLSERV.NRLOCALCLIENTE
                    LEFT JOIN CLIENTE
                        ON FCM_LOCALCLI.CDCLIENTE = CLIENTE.CDCLIENTE
                        WHERE SOLSERV.IDSITUACAO = :IDSITUACAO";
        
        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $parametros);
    }

    /* Fim rotina do Kanban */

    public function getProfissionalExterno() 
    {
        $sql = "SELECT NMPROFISSIONALEXTERNO, NRPROFISSIONALEXTERNO
                    FROM FCM_PROFISSIONALEXTERNO";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function insertRelacaoEpis($parametros) 
    {
        $sql = "INSERT INTO FCM_RELACEPIORDEMS (NRRELACEPIORDEMS, NREPI, NRORDEMSERV, IDATIVO, NRORG, DTINCLUSAO, CDOPERINCLUSAO, NRORGINCLUSAO)
                VALUES (:NRRELACEPIORDEMS, :NREPI, :NRORDEMSERV, 'S',  :NRORG, SYSDATE, :CDOPERINCLUSAO, :NRORGINCLUSAO)";
        
        $this->connection->executeStatement($sql, $parametros);
    }

    public function insertProfissionalExterno($parametros) 
    {        
        $sql = "INSERT INTO FCM_PROFISSIONALEXTERNO (NRPROFISSIONALEXTERNO, NMPROFISSIONALEXTERNO, NMEMPRESA, INSCRICAO, IDATIVO, NRORG, DTINCLUSAO, CDOPERINCLUSAO, NRORGINCLUSAO)
                VALUES (:NRPROFISSIONALEXTERNO, :NMPROFISSIONALEXTERNO, :NMEMPRESA, :INSCRICAO, 'S',  :NRORG, SYSDATE, :CDOPERINCLUSAO, :NRORGINCLUSAO)";


        return $this->connection->executeStatement($sql, $parametros);
    }

    public function insertRelacaoResponsavelOrdem($parametros) 
    {        
        $sql = "INSERT INTO FCM_RESPONSAVELORDEMS (NRRESPONSAVELORDEMS, NRORDEMSERV, NRPROFISSIONALEXTERNO, CDOPERADOR, IDATIVO, NRORG, DTINCLUSAO, CDOPERINCLUSAO, NRORGINCLUSAO)
                VALUES (:NRRESPONSAVELORDEMS, :NRORDEMSERV, :NRPROFISSIONALEXTERNO, :CDOPERADOR, 'S',  :NRORG, SYSDATE, :CDOPERINCLUSAO, :NRORGINCLUSAO)";

        return $this->connection->executeStatement($sql, $parametros);
    }
}
