import {
    IterableComponentRender,
    Modal, ModalService,
} from '@zeedhi/common';
import { IEventParam, Metadata } from '@zeedhi/core';
import { IterableCarousel } from '@zeedhi/teknisa-components-common';
import { TekIterableComponentRender } from '@zeedhi/teknisa-components-vuetify';

export class FmKanbanAuditoriaController {
    public modal!: Modal;

    public nrauditoria: string = '';

    public async abrirModal({ component }: any) {
        /* eslint-disable */
        this.nrauditoria = component.name.split('_')[0];
        const idsituacao = component.name.split('_')[1];
         /* eslint-enable */

        if (idsituacao !== '1') {
            await this.modal.show();
            this.onMountedCategorias();
        }
    }

    public async criarModais() {
        this.modal = await ModalService.createFromJsonPost('', { jsonPath: 'fm_00040_000_auditoria/modal/visualizar_infos_kanban_auditorias' });
    }

    public destruirModais() {
        this.modal.destroy();
    }

    public fecharModal() {
        this.modal.hide();
    }

    public onMountedCategorias() {
        Metadata.getInstance<TekIterableComponentRender>('iterable-categorias-kanban').datasource.setFilter({
            NRAUDITORIA: this.nrauditoria,
        });
    }

    public getTopicos({ component }: IEventParam<IterableComponentRender>) {
        component.datasource.setFilter({
            NRCATEGORIAAUDIT: component.name.split('_')[1],
            NRAUDITORIA: this.nrauditoria,
        });
    }

    public getCriterios({ component }: IEventParam<TekIterableComponentRender>) {
        component.datasource.setFilter({
            NRTOPICOAUDIT: component.name.split('_')[1],
            NRCATEGORIAAUDIT: component.name.split('_')[2],
            NRAUDITORIA: this.nrauditoria,
        });
    }

    public onMountedImagensAnexadas({ component }: IEventParam<IterableCarousel>) {
        component.iterable.datasource.setFilter({
            NRAUDITORIA: this.nrauditoria,
            NRCATEGORIAAUDIT: component.name.split('_')[2],
            NRTOPICOAUDIT: component.name.split('_')[1],
        });
    }
}
